{$IFDEF FPC}
{$MODE Delphi}
{$ASMMODE intel}
{$GOTO ON}
{$DEFINE KOL_MCK}
{$ENDIF}


{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,
  mckCtrls {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Panel1: TKOLPanel;
    Btn1: TKOLButton;
    Scroll1: TKOLScrollBox;
    OpenDlg: TKOLOpenSaveDialog;
    Image: TKOLPanel;
    procedure Btn1Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure KOLForm1Destroy(Sender: PObj);
    procedure ImagePaint(Sender: PControl; DC: HDC);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses KOLGraphicEx;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

var
  BMP: PBitmap;
  IMG: PStream;

  SGI: TSGIGraphic;
  CEL: TAutodeskGraphic;
  TIF: TTIFFGraphic;
  EPS: TEPSGraphic;
  TGA: TTGAGraphic;
  PCX: TPCXGraphic;
  PCD: TPCDGraphic;
  PPM: TPPMGraphic;
  CUT: TCUTGraphic;
  GIF: TGIFGraphic;
  RLA: TRLAGraphic;
  PSD: TPSDGraphic;
  PSP: TPSPGraphic;
  PNG: TPNGGraphic;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  BMP:=NewBitmap(1,1);
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
begin
  BMP.Free;
end;

procedure TForm1.ImagePaint(Sender: PControl; DC: HDC);
begin
  Image.Width:=BMP.Width;
  Image.Height:=BMP.Height;
  BMP.Draw(DC,0,0);
end;

procedure TForm1.Btn1Click(Sender: PObj);
var X,Y,BPP: dword;
    C: string;
begin
  if not OpenDlg.Execute then Exit;
  IMG:=NewReadFileStream(OpenDlg.Filename);
  case OpenDlg.FilterIndex of
  // TSGIGraphic
    1: begin
         SGI:=TSGIGraphic.Create;
         X:=0;
         Y:=0;
         if SGI.CanLoad(IMG) then
           begin
             SGI.LoadFromStream(IMG);
             BMP.Assign(SGI.Bitmap);
             X:=SGI.ImageProperties.Width;
             Y:=SGI.ImageProperties.Height;
             C:=Comp2Str[SGI.ImageProperties.Compression];
             BPP:=SGI.ImageProperties.BitsPerPixel;
           end;
         SGI.Free;
       end;
  // TAutodeskGraphic
    2: begin
         CEL:=TAutodeskGraphic.Create;
         X:=0;
         Y:=0;
         if CEL.CanLoad(IMG) then
           begin
             CEL.LoadFromStream(IMG);
             BMP.Assign(CEL.Bitmap);
             X:=CEL.ImageProperties.Width;
             Y:=CEL.ImageProperties.Height;
             C:=Comp2Str[CEL.ImageProperties.Compression];
             BPP:=CEL.ImageProperties.BitsPerPixel;
           end;
         CEL.Free;
       end;
  // TTIFFGraphic
    3: begin
         TIF:=TTIFFGraphic.Create;
         X:=0;
         Y:=0;
         if TIF.CanLoad(IMG) then
           begin
             TIF.LoadFromStream(IMG);
             BMP.Assign(TIF.Bitmap);
             X:=TIF.ImageProperties.Width;
             Y:=TIF.ImageProperties.Height;
             C:=Comp2Str[TIF.ImageProperties.Compression];
             BPP:=TIF.ImageProperties.BitsPerPixel;
           end;
         TIF.Free;
       end;
  // TEPSGraphic
    4: begin
         EPS:=TEPSGraphic.Create;
         X:=0;
         Y:=0;
         if EPS.CanLoad(IMG) then
           begin
             EPS.LoadFromStream(IMG);
             BMP.Assign(EPS.Bitmap);
             X:=EPS.ImageProperties.Width;
             Y:=EPS.ImageProperties.Height;
             C:=Comp2Str[EPS.ImageProperties.Compression];
             BPP:=EPS.ImageProperties.BitsPerPixel;
           end;
         EPS.Free;
       end;
  // TTGAGraphic
    5: begin
         TGA:=TTGAGraphic.Create;
         X:=0;
         Y:=0;
         if TGA.CanLoad(IMG) then
           begin
             TGA.LoadFromStream(IMG);
             BMP.Assign(TGA.Bitmap);
             X:=TGA.ImageProperties.Width;
             Y:=TGA.ImageProperties.Height;
             C:=Comp2Str[TGA.ImageProperties.Compression];
             BPP:=TGA.ImageProperties.BitsPerPixel;
           end;
         TGA.Free;
       end;
  // TPCXGraphic
    6: begin
         PCX:=TPCXGraphic.Create;
         X:=0;
         Y:=0;
         if PCX.CanLoad(IMG) then
           begin
             PCX.LoadFromStream(IMG);
             BMP.Assign(PCX.Bitmap);
             X:=PCX.ImageProperties.Width;
             Y:=PCX.ImageProperties.Height;
             C:=Comp2Str[PCX.ImageProperties.Compression];
             BPP:=PCX.ImageProperties.BitsPerPixel;
           end;
         PCX.Free;
       end;
  // TPCDGraphic
    7: begin
         PCD:=TPCDGraphic.Create;
         X:=0;
         Y:=0;
         if PCD.CanLoad(IMG) then
           begin
             PCD.LoadFromStream(IMG);
             BMP.Assign(PCD.Bitmap);
             X:=PCD.ImageProperties.Width;
             Y:=PCD.ImageProperties.Height;
             C:=Comp2Str[PCD.ImageProperties.Compression];
             BPP:=PCD.ImageProperties.BitsPerPixel;
           end;
         PCD.Free;
       end;
  // TPPMGraphic
    8: begin
         PPM:=TPPMGraphic.Create;
         X:=0;
         Y:=0;
         if PPM.CanLoad(IMG) then
           begin
             PPM.LoadFromStream(IMG);
             BMP.Assign(PPM.Bitmap);
             X:=PPM.ImageProperties.Width;
             Y:=PPM.ImageProperties.Height;
             C:=Comp2Str[PPM.ImageProperties.Compression];
             BPP:=PPM.ImageProperties.BitsPerPixel;
           end;
         PPM.Free;
       end;
  // TCUTGraphic
    9: begin
         CUT:=TCUTGraphic.Create;
         X:=0;
         Y:=0;
         if CUT.CanLoad(IMG) then
           begin
             CUT.PaletteFile:=ChangeFileExt(OpenDlg.Filename,'.pal');
             CUT.LoadFromStream(IMG);
             BMP.Assign(CUT.Bitmap);
             X:=CUT.ImageProperties.Width;
             Y:=CUT.ImageProperties.Height;
             C:=Comp2Str[CUT.ImageProperties.Compression];
             BPP:=CUT.ImageProperties.BitsPerPixel;
           end;
         CUT.Free;
       end;
  // TGIFGraphic
   10: begin
         GIF:=TGIFGraphic.Create;
         X:=0;
         Y:=0;
         if GIF.CanLoad(IMG) then
           begin
             GIF.LoadFromStream(IMG);
             BMP.Assign(GIF.Bitmap);
             X:=GIF.ImageProperties.Width;
             Y:=GIF.ImageProperties.Height;
             C:=Comp2Str[GIF.ImageProperties.Compression];
             BPP:=GIF.ImageProperties.BitsPerPixel;
           end;
         GIF.Free;
       end;
  // TRLAGraphic
   11: begin
         RLA:=TRLAGraphic.Create;
         X:=0;
         Y:=0;
         if RLA.CanLoad(IMG) then
           begin
             RLA.LoadFromStream(IMG);
             BMP.Assign(RLA.Bitmap);
             X:=RLA.ImageProperties.Width;
             Y:=RLA.ImageProperties.Height;
             C:=Comp2Str[RLA.ImageProperties.Compression];
             BPP:=RLA.ImageProperties.BitsPerPixel;
           end;
         RLA.Free;
       end;
  // TPSDGraphic
   12: begin
         PSD:=TPSDGraphic.Create;
         X:=0;
         Y:=0;
         if PSD.CanLoad(IMG) then
           begin
             PSD.LoadFromStream(IMG);
             BMP.Assign(PSD.Bitmap);
             X:=PSD.ImageProperties.Width;
             Y:=PSD.ImageProperties.Height;
             C:=Comp2Str[PSD.ImageProperties.Compression];
             BPP:=PSD.ImageProperties.BitsPerPixel;
           end;
         PSD.Free;
       end;
  // TPSPGraphic
   13: begin
         PSP:=TPSPGraphic.Create;
         X:=0;
         Y:=0;
         if PSP.CanLoad(IMG) then
           begin
             PSP.LoadFromStream(IMG);
             BMP.Assign(PSP.Bitmap);
             X:=PSP.ImageProperties.Width;
             Y:=PSP.ImageProperties.Height;
             C:=Comp2Str[PSP.ImageProperties.Compression];
             BPP:=PSP.ImageProperties.BitsPerPixel;
           end;
         PSP.Free;
       end;
  // TPNGGraphic
   14: begin
         PNG:=TPNGGraphic.Create;
         X:=0;
         Y:=0;
         if PNG.CanLoad(IMG) then
           begin
             PNG.LoadFromStream(IMG);
             BMP.Assign(PNG.Bitmap);
             X:=PNG.ImageProperties.Width;
             Y:=PNG.ImageProperties.Height;
             C:=Comp2Str[PNG.ImageProperties.Compression];
             BPP:=PNG.ImageProperties.BitsPerPixel;
           end;
         PNG.Free;
       end;
  end;
  IMG.Free;
  {$IFNDEF FPC}
  if (X<>0) and (Y<>0) then C:=Format('Image size %dx%d pixels, %d bits per pixel, %s compression',[X,Y,BPP,C]) else C:='';
  Form.SimpleStatusText:=PChar(C);
  {$ENDIF}
  ImagePaint(Image,Image.Canvas.Handle);
end;

end.

